## swift-im 5.0~alpha2.145.g12d031cf8+dfsg

=== Makefile ===

NUM_CPU := $(shell python -c 'import multiprocessing; print(multiprocessing.cpu_count())')

.PHONY: all
all: build.ninja
	ninja

.PHONY: clang-tidy
clang-tidy: compile_commands.json
	ninja -t targets all | grep cxx | grep -v 3rdParty | sed -e's/\.o: cxx/.cpp/' | xargs -t -P ${NUM_CPU} -n 1 clang-tidy -warnings-as-errors=*

.PHONY: clang-tidy-fix
clang-tidy-fix: compile_commands.json
	ninja -t targets all | grep cxx | grep -v 3rdParty | sed -e's/\.o: cxx/.cpp/' | xargs -t -P ${NUM_CPU} -n 1 -I{} clang-tidy -p=${PWD} -export-fixes={}.clang-tidy-changes.yaml {}
	clang-apply-replacements -remove-change-desc-files ${PWD}

compile_commands.json: build.ninja
	ninja -t compdb cxx > compile_commands.json

build.ninja:
	./BuildTools/scons2ninja.py check=1 build_examples=0

=== SConstruct ===
variant_dir = SConscript("BuildTools/SCons/SConscript.boot")
if variant_dir :
    SConscript("BuildTools/SCons/SConstruct", variant_dir = variant_dir, src_dir = ".")
else :
    SConscript("BuildTools/SCons/SConstruct")

=== BuildTools/SCons/SConstruct ===
import sys, os, re, platform
import SCons.SConf

Import("env", "conf_env")

root = Dir("../..").abspath

# Override SConscript to handle tests
oldSConscript = SConscript
def SConscript(*args, **kwargs) :
    if not kwargs.get("test_only", False) or env["TEST"] :
        return oldSConscript(*args, **kwargs)
env.SConscript = SConscript

################################################################################
# Extend the default build environment (not affecting the configure env)
#
# Keeping both environments separated mostly because of SCons Issue 2391,
# although it doesn't hurt to separate them (e.g. not have pretty printed
# strings in config.log)
################################################################################

#if env["PLATFORM"] == "win32" :
#   env["MSVC_BATCH"] = 1

# Pretty output
def colorize(command, target, color) :
    colors = { "red": "31", "green": "32", "yellow": "33", "blue": "34" }
    prefix = ""
    suffix = ""
    if sys.stdout.isatty() and env["PLATFORM"] != "win32":
        prefix = "\033[0;" + colors[color] + ";140m"
        suffix = "\033[0m"
    return "  " + prefix + command + suffix + " " + target

if int(ARGUMENTS.get("V", 0)) == 0 and not ARGUMENTS.get("dump_trace", False) :
    env["CCCOMSTR"] = colorize("CC", "$TARGET", "green")
    env["SHCCCOMSTR"] = colorize("CC", "$TARGET", "green")
    env["CXXCOMSTR"] = colorize("CXX", "$TARGET", "green")
    env["SHCXXCOMSTR"] = colorize("CXX", "$TARGET", "green")
    env["LINKCOMSTR"] = colorize("LINK", "$TARGET", "red")
    env["SHLINKCOMSTR"] = colorize("LINK", "$TARGET", "red")
    env["ARCOMSTR"] = colorize("AR", "$TARGET", "red")
    env["RANLIBCOMSTR"] = colorize("RANLIB", "$TARGET", "red")
    env["PCHCOMSTR"] = colorize("PCH", "$TARGET", "blue")
    env["QT4_RCCCOMSTR"] = colorize("RCC", "$TARGET", "blue")
    env["QT4_UICCOMSTR"] = colorize("UIC", "$TARGET", "blue")
    env["QT4_MOCFROMHCOMSTR"] = colorize("MOC", "$TARGET", "blue")
    env["QT4_MOCFROMCXXCOMSTR"] = colorize("MOC", "$TARGET", "blue")
    env["QT4_LRELEASECOMSTR"] = colorize("LRELEASE", "$TARGET", "blue")
    env["QT4_LUPDATECOMSTR"] = colorize("LUPDATE", "$TARGET", "blue")
    env["GENCOMSTR"] = colorize("GEN", "$TARGET", "blue")
    env["RCCOMSTR"] = colorize("RC", "$TARGET", "blue")
    env["BUNDLECOMSTR"] = colorize("BUNDLE", "$TARGET", "blue")
    env["NIBCOMSTR"] = colorize("NIB", "$TARGET", "blue")
    env["NSISCOMSTR"] = colorize("NSIS", "$TARGET", "blue")
    env["INSTALLSTR"] = colorize("INSTALL", "$TARGET", "blue")
    env["TESTCOMSTR"] = colorize("TEST", "$SOURCE", "yellow")
    env["FOCOMSTR"] = colorize("FO", "$TARGET", "blue")
    env["XSLTCOMSTR"] = colorize("XSLT", "$TARGET", "blue")
    env["XMLLINTCOMSTR"] = colorize("XMLLINT", "$SOURCE", "blue")
    env["DOXYCOMSTR"] = colorize("DOXY", "$SOURCE", "blue")
    #Progress(colorize("DEP", "$TARGET", "red")

def checkObjCHeader(context, header) :
    context.Message("Checking for Objective-C header " + header + " ... ")
    ret = context.TryCompile("#include <Cocoa/Cocoa.h>\n#include <" + header + ">", ".m")
    context.Result(ret)
    return ret

def checkForCpp11Support(context) :
    context.Message('Checking whether the C++ compiler supports C++11... ')
    result = context.TryLink(
        """
#include <memory>

int main(int, char **) {
    // shared_ptr test
    std::shared_ptr<int> intPtr = std::make_shared<int>();

    // unique_ptr test
    std::unique_ptr<int> intPtrUnique = std::unique_ptr<int>(new int(1));

    // auto test
    auto otherIntPtr = intPtr;
    std::shared_ptr<int> fooIntPtr = otherIntPtr;

    // lambda test
    auto someFunction = [](int i){ i = i * i; };
    someFunction(2);

    // nullptr test
    double* fooDouble = nullptr;
    double bazDouble = 8.0;
    fooDouble = &bazDouble;
    bazDouble = *fooDouble;

    return 0;
}
""", '.cpp')
    context.Result(result)
    return result


################################################################################
# Platform configuration
################################################################################

if ARGUMENTS.get("force-configure", 0) :
    SCons.SConf.SetCacheMode("force")

def CheckPKG(context, name):
    context.Message( 'Checking for package %s... ' % name )
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    context.Result( ret )
    return ret

def CheckVersion(context, library, version, define, header, value) :
    context.Message("Checking " + library + " version (>= " + version + ") ...")
    version = GetVersion(context, define, header)
    ok = version >= value
    context.Result(ok)
    return ok

def GetVersion(context, define, header, extension = ".c") :
    ret = context.TryRun("""
#include <%(header)s>
#include <stdio.h>

int main(int argc, char* argv[]) {
    printf("%%d\\n", %(define)s);
    return 0;
}
""" % { "header" : header, "define": define }, extension)
    if ret[0] :
        return int(ret[1])
    else :
        return -1

conf = Configure(conf_env, custom_tests = {
    'CheckCpp11Support' : checkForCpp11Support,
    })

if not conf.CheckCXX() or not conf.CheckCC() :
    print("Error: You need a working compiler")
    Exit(1)

if not conf.CheckCpp11Support() :
    print("Error: You need a compiler with support for the C++11 standard")
    Exit(1)


env["HAVE_ZLIB"] = True
zlib_flags = {}
zlib_okay = False
if env.get("zlib_libdir", None) :
    zlib_flags["LIBPATH"] = [env["zlib_libdir"]]
    zlib_okay = True
if env.get("zlib_includedir", None) :
    zlib_flags["CPPPATH"] = [env["zlib_includedir"]]
    zlib_okay = True
if env.get("zlib_libfile", None) :
    zlib_flags["LIBS"] = [File(env["zlib_libfile"])]
    zlib_okay = True
elif zlib_okay :
    zlib_flags["LIBS"] = ["z"]
if (not zlib_okay) and conf.CheckLib("z") :
    zlib_flags["LIBS"] = ["z"]
    zlib_okay = True
if zlib_okay :
    env["ZLIB_FLAGS"] = zlib_flags
elif not env.get("zlib_bundled_enable", True) :
    print("Error: Zlib not found and zlib_bundled_enable is false")
    Exit(1)
else :
    env["ZLIB_BUNDLED"] = True

if conf.CheckLib("resolv") :
    env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["resolv"]

if env["PLATFORM"] != "win32" :
    if conf.CheckLib("pthread") :
        env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["pthread"]

if conf.CheckLib("dl") :
    env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["dl"]

if conf.CheckLib("m") :
    env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["m"]

if conf.CheckLib("c") :
    env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["c"]

# Even if you find stdc++ on HP-UX, it is the wrong one for aCC
if env["PLATFORM"] != "hpux" :
    if conf.CheckLib("stdc++", language='CXX') :
        env["PLATFORM_FLAGS"]["LIBS"] = env["PLATFORM_FLAGS"].get("LIBS", []) + ["stdc++"]
conf.Finish()

# Boost
boost_conf_env = conf_env.Clone()
boost_flags = {}
if env.get("boost_libdir", None) :
    boost_flags["LIBPATH"] = [env["boost_libdir"]]
if env.get("boost_includedir", None) :
    if env["PLATFORM"] == "win32" or env["PLATFORM"] == "hpux" or env["PLATFORM"] == "sunos" :
        boost_flags["CPPPATH"] = [env["boost_includedir"]]
    else :
        # Using isystem to avoid getting warnings from a system boost
        # Unfortunately, this also disables dependency tracking
        boost_flags["CPPFLAGS"] = [("-isystem", env["boost_includedir"])]
boost_conf_env.MergeFlags(boost_flags)
conf = Configure(boost_conf_env)
boostLibs = [(None, "signals2.hpp"), ("system", "system/system_error.hpp"), ("thread", None), ("regex", None), ("program_options", None), ("filesystem", None), ("serialization", "archive/text_oarchive.hpp"), ("date_time", "date_time/date.hpp")]
allLibsPresent = True
libNames = []
for (lib, header) in boostLibs :
    if header :
        header = "boost/" + header
    else :
        header = "boost/" + lib + ".hpp"
    if not conf.CheckCXXHeader(header) :
        allLibsPresent = False
        break
    if lib and env["PLATFORM"] != "win32" :
        libName = "boost_" + lib
        if not conf.CheckLib(libName, language='CXX') :
            libName += "-mt"
            if not conf.CheckLib(libName, language='CXX') :
                allLibsPresent = False
                break
        libNames.append(libName)
if not env.get("boost_force_bundled") and allLibsPresent :
    env["BOOST_FLAGS"] = boost_flags
    if env["PLATFORM"] != "win32" :
        env["BOOST_FLAGS"].update({"LIBS": libNames})
    if not conf.CheckCXXHeader("boost/uuid/uuid.hpp") :
        # FIXME: Remove this workaround when UUID is available in most distros
        env["BOOST_BUNDLED_UUID_ONLY"] = True
elif not env.get("boost_bundled_enable", True) :
    print("Error: Boost not found and boost_bundled_enable is false")
    Exit(1)
else :
    env["BOOST_BUNDLED"] = True
boost_version = GetVersion(conf, "BOOST_VERSION", "boost/version.hpp")
if boost_version == 106400 :
    #Version 1.64 has some issues with the serialization of boost::optional, see https://svn.boost.org/trac10/ticket/13050
    env["BOOST_1_64_DETECTED"] = True
else:
    env["BOOST_1_64_DETECTED"] = False
conf.Finish()


# Xss
env["HAVE_XSS"] = 0
if env["PLATFORM"] != "win32" and env["PLATFORM"] != "darwin" :
    xss_flags = {
            "LIBPATH": ["/usr/X11R6/lib"],
            "LIBS": ["Xss"]
        }
    xss_env = conf_env.Clone()
    xss_env.MergeFlags(xss_flags)
    conf = Configure(xss_env)
    if conf.CheckFunc("XScreenSaverQueryExtension") :
        env["HAVE_XSS"] = 1
        env["XSS_FLAGS"] = xss_flags
    conf.Finish()

# GConf
env["HAVE_GCONF"] = 0
if env.get("try_gconf", True) and env["PLATFORM"] != "win32" and env["PLATFORM"] != "darwin" :
    gconf_env = conf_env.Clone()
    conf = Configure(gconf_env, custom_tests = {"CheckPKG": CheckPKG})
    if conf.CheckPKG("gconf-2.0") :
        gconf_bare_env = Environment()
        gconf_bare_env.ParseConfig('pkg-config --cflags gconf-2.0 gobject-2.0 --libs gconf-2.0 gobject-2.0')
        if os.path.basename(env["CXX"]).startswith(("g++", "clang++")) :
            gconf_bare_env["CCFLAGS"] = [("-isystem" + ccflag) for ccflag in gconf_bare_env["CPPPATH"]]
            gconf_bare_env["CPPPATH"] = []
        gconf_flags = {
                "LIBS": gconf_bare_env["LIBS"],
                "CCFLAGS": gconf_bare_env["CCFLAGS"],
                "CPPPATH": gconf_bare_env["CPPPATH"],
                "CPPDEFINES": gconf_bare_env.get("CPPDEFINES", []),
            }
        gconf_env.MergeFlags(gconf_flags)
        if conf.CheckCHeader("gconf/gconf-client.h") and conf.CheckLib("gconf-2") :
            env["HAVE_GCONF"] = 1
            env["GCONF_FLAGS"] = {
                "LIBS": gconf_env["LIBS"],
                "CCFLAGS": gconf_env["CCFLAGS"],
                "CPPPATH": gconf_env.get("CPPPATH", []),
                "CPPDEFINES": gconf_env.get("CPPDEFINES", []),
            }
    conf.Finish()

# Sparkle
env["HAVE_SPARKLE"] = 0
if env["PLATFORM"] == "darwin" :
    sparkle_flags = {
            "FRAMEWORKPATH": ["3rdParty/Sparkle/Sparkle-1.14.0"],
            "FRAMEWORKS": ["Sparkle"]
        }
    sparkle_env = conf_env.Clone()
    sparkle_env.MergeFlags(sparkle_flags)
    conf = Configure(sparkle_env, custom_tests = { "CheckObjCHeader" : checkObjCHeader })
    if conf.CheckObjCHeader("Sparkle/Sparkle.h") :
        env["HAVE_SPARKLE"] = 1
        env["SPARKLE_FLAGS"] = sparkle_flags
        env["SPARKLE_FRAMEWORK"] = Dir("../../3rdParty/Sparkle/Sparkle-1.14.0/Sparkle.framework")
        env["SPARKLE_COPYING"] = File("../../3rdParty/Sparkle/Sparkle-1.14.0/LICENSE")
    conf.Finish()

    if env.get("sparkle_public_dsa_key", None) != None :
        env["SWIFT_SPARKLE_PUBLIC_DSA_KEY"] = File(env.get("sparkle_public_dsa_key"))
    else :
        env["SWIFT_SPARKLE_PUBLIC_DSA_KEY"] = None

# Growl
env["HAVE_GROWL"] = 0
if env["PLATFORM"] == "darwin" :
    growl_flags = {

=== debian/changelog ===
swift-im (5.0~alpha2.145.g12d031cf8+dfsg-5) unstable; urgency=medium

  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead nproc (Closes: #1109963)
    Thanks to Michael Crusoe for the patch!
  * Drop B-D on oboslete libqt5webkit5-dev.

 -- Tobias Frost <tobi@debian.org>  Sat, 20 Sep 2025 00:08:34 +0200

swift-im (5.0~alpha2.145.g12d031cf8+dfsg-4) unstable; urgency=medium

  * Fix FTBFS with miniupnpc 2.2.8 (Closes: #1076692).
  * Add patch for a FTBFS issue with GCC 14.

 -- Tobias Frost <tobi@debian.org>  Sat, 03 Aug 2024 09:41:56 +0200

swift-im (5.0~alpha2.145.g12d031cf8+dfsg-3) unstable; urgency=medium

  * Make build reproducible by pre-generating VERSION.swift. Thanks
    to Vagrant for proposing a fix! (Closes: #1024292)
  * Fix generated version.h, see patch fix-version-h.patch and d/rules.
    (Closes: #1024553)
  * Bump S-V to 4.6.2, no changes.
  * Bump d/copyright years.

 -- Tobias Frost <tobi@debian.org>  Sat, 04 Feb 2023 14:02:27 +0100

swift-im (5.0~alpha2.145.g12d031cf8+dfsg-2) unstable; urgency=medium

  * No-change source-only upload to build on buildds.

 -- Tobias Frost <tobi@debian.org>  Sun, 23 Oct 2022 19:08:40 +0200

swift-im (5.0~alpha2.145.g12d031cf8+dfsg-1) unstable; urgency=medium

  * Reintroduce Package. (Closes: #1016962)
  * The package will be maintained in the realms of the XMPP Team.
  * d/copyright: review and updated
  * d/control:
    - Remove uneeded version constraints on B-D.
    - Rename library package to match upstream SONAME zero.
    - Point Vcs fields to salsa.
    - Use https for Upstream field.
    - Note that rules won't require root privileges.
    - Update S-V to 4.6.1 -- no changes.
    - Don't package swift-im. (Scons woni't find QT; as this is packaged
      for spectrum2, it is also not needed now.)
  * d/rules:
    - Rework d/rules / d/clean to get rid of scons in the clean target.
    - Enable hardening.
  * Add an customized CI configuration, allowing repotest to fail.

 -- Tobias Frost <tobi@debian.org>  Mon, 17 Oct 2022 14:29:03 +0200

swift-im (4.0.3+dfsg1-1) UNRELEASED; urgency=medium

  * Team upload.
  * Reintroduce this source package, although building only the
    swiften library as we need it for the spectrum2 transport
  * New upstream version
  * Completely new packaging

 -- Thorsten Glaser <tg@mirbsd.de>  Sun, 26 Apr 2020 20:48:15 +0200

swift-im (3.0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix encoding error in scons Python script. (Closes: #889062)
  * Fix build on i386 with Qt. (Closes: #840151)
  * Fix missing dependency on zlib. (Closes: #844879)
  * Fix build against current miniupnp.

 -- Dominik George <natureshadow@debian.org>  Mon, 20 May 2019 15:14:47 +0200

=== debian/control ===
Source: swift-im
Section: net
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@alioth-lists.debian.net>
Uploaders: Tobias Frost <tobi@debian.org>
Build-Depends: debhelper-compat (= 13),
               docbook-xml,
               docbook-xsl,
               help2man,
               libavahi-client-dev,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libhunspell-dev,
               libidn-dev,
               libminiupnpc-dev,
               libnatpmp-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               libsqlite3-dev,
               libssl-dev,
               libxml2-dev,
               libxml2-utils,
               libxss-dev,
               qt5-image-formats-plugins,
               qtbase5-dev,
               qtbase5-dev-tools,
               qtchooser,
               qtmultimedia5-dev,
               qttools5-dev-tools,
               scons,
               xsltproc,
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/xmpp-team/swift-im.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/swift-im
Homepage: https://swift.im
Rules-Requires-Root: no

Package: libswiften0
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: XMPP library
 Swiften is a robust, high-quality, standards-compliant, cross-platform,
 and performant C++ library for implementing XMPP applications. Swiften
 is used as the back-end library for the Swift Instant Messaging client.

Package: libswiften-dev
Architecture: any
Section: libdevel
Depends: libboost-date-time-dev,
         libboost-dev,
         libboost-filesystem-dev,
         libboost-regex-dev,
         libboost-thread-dev,
         libswiften0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: XMPP library (development files)
 Swiften is a robust, high-quality, standards-compliant, cross-platform,
 and performant C++ library for implementing XMPP applications. Swiften
 is used as the back-end library for the Swift Instant Messaging client.
 .
 This package contains the header development files and programs for
 developing with Swiften.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildopts.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#export DH_VERBOSE=1
export PYTHONDONTWRITEBYTECODE=1
export QT_SELECT=qt5
# if used with ccache, the build system uses $HOME…
export HOME=$(CURDIR)/debian/scons_home

SCONS_FLAGS=V=1 qt5=1 optimize=1 debug=1 allow_warnings=1 swiften_dll=1 \
                help2man=1 docbook_xsl=/usr/share/xml/docbook/stylesheet/docbook-xsl \
                docbook_xml=/usr/share/xml/docbook/schema/dtd/4.5 \
                linkflags="$(shell dpkg-buildflags --get LDFLAGS)" \
                ccflags="$(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS) $(shell echo -std=c++17)"

# kept for now: line required to detect lua: lua_includedir="/usr/include/lua5.1" lua_libname="lua5.1" \

# It get's it own version wrong… #1024553. (needs also fix-version-h.patch)
export SWIFTEN_VERSION=$(DEB_VERSION_UPSTREAM)

SCONS_INSTALL_BASE=$(CURDIR)/debian/tmp
SCONS_INSTALL_FLAGS=SWIFT_INSTALLDIR=$(SCONS_INSTALL_BASE)/usr \
        SWIFTEN_INSTALLDIR=$(SCONS_INSTALL_BASE)/usr \
        SWIFTEN_LIBINSTALLDIR=$(SCONS_INSTALL_BASE)/usr/lib/$(DEB_HOST_MULTIARCH)

ifneq (, $(shell which ccache))
SCONS_FLAGS+=ccache=1
endif

%:
	dh $@

override_dh_auto_build:
	mkdir -p $(HOME)
	echo $(DEB_UPSTREAM_VERSION) > VERSION.swift
	scons $(DEB_BUILD_OPTION_PARALLEL:%=--jobs=%) $(SCONS_FLAGS) Swiften

override_dh_auto_install:
	scons $(SCONS_FLAGS) $(SCONS_INSTALL_FLAGS) $(SCONS_INSTALL_BASE) Swiften

=== debian/watch ===
version=4
opts="mode=git,pretty=describe, \
    uversionmangle=s/swift\.//g;s/(alpha|beta|rc)/~$1/g, \
    dversionmangle=s/\+dfsg[0-9]+$//, repacksuffix=+dfsg, \
    pgpmode=none"  \
    git://swift.im/swift HEAD
